///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////									///////////////////////////////////////////////////
/////////////////////		GHOSTDUDE'S EXPLOSIONS WDL			///////////////////////////////////////////////////
/////////////////////									///////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//To use:
//	add this line after tha last include statement in your game's script:
//	
//	include <explo_wdl.wdl>;
//
//
//
//
//Contains these actions/functions:
//	small_explo
//	explosion_maker
//	explo_particle
//
//	and includes all sprites and sounds used.
//
//
//
//When ever you need an explosion, just use add one of these groups of lines to the entity's action:
//	
// 	ent_create(gibbit_mdl,my.pos,explosion_maker);
//
//	-or-
//
//	ent_create(small_explo_bmp,my.pos,small_explo);
//			
//	-or-
//
//	effect(explo_particle,200,my.pos,nullvector);
//
//	-or any combination of these.
//
//	
//	
//
//
//BEST IF USED WITH MY EXPLOSIONS TUTORIAL @
//www.angelfire.com/mi4/gh0s7mp630/Explosion_Tut.zip
//	(you need to capitalize the capital letters)
//
//
//
// These scripts are completelly free for anyone to use,
//	just please give some credit to me (GhostDude).
//
//	Have fun!


string small_explo_bmp = <expl2+16.pcx>;	//animated explosion sprite
sound explosion_snd = <explosion.wav>;	//explosion sound
string gibbit_mdl = <qkey3.mdl>;		//gibbit.mdl
bmap blitz_map = <blitz.pcx>;			//bitmap for particles
bmap fball_map = <fball_mod.pcx>;		//bitmap for particles


function fading_particle {
	my.alpha -= my.skill11 * time;
}

function explo_particle() {			//particle explosion
	my.size = random(4) + 1;
	if(random(1) >= .5) {my.bmap = blitz_map;}
	else{my.bmap = fball_map;}
	my.red = 255;
	my.green = random(100) + 25;
	my.blue = random(20);
	my.vel_x = random(8) - 4;
	my.vel_y = random(8) - 4;
	my.vel_z = random(8)+2;
	my.move = on;
	my.gravity = 1;
	my.bright = on;
	my.flare = on;
	my.alpha = random(20) + 80;
	my.lifespan = random(5) + 20;
	my.skill11 = my.alpha / my.lifespan;
	my.function = fading_particle;
}


action small_explo { 					//single animated sprite
	ent_playsound(my,explosion_snd,1000);	
	my.facing = on;
	my.passable = on;
	my.bright = on;
	my.transparent = on;
	vec_scale(my.scale_x,0.5);
	my.alpha = 100;
	my.lightrange = 400;
	my.lightred = 255;
	my.lightgreen = 255;
	my.lightblue = 255;
	while(my != null) {
		my.frame += 1 * time;
		my.scale_x += .1 * time;
		my.scale_y += .1 * time;
		my.alpha -= 5 * time;
		my.lightred -= 15 * time;
		my.lightgreen -= 20 * time;
		my.lightblue -= 25 * time; 
		if (my.frame >= 16) {remove(me);}
		wait(1);
	}
}

action explosion_maker {		//creates multiple sprites
	my.skill30 = 5;
	my.passable = on;
	my.invisible = on;
	my.visible = off;
	//you.skill30 = 16;
	while(my.skill30 > 0) {
		my.skill30 -= 1;
		temp.x = my.x + random(50) - 50;
		temp.y = my.y + random(50) - 50;
		temp.z = my.z + random(50) - 25;
		ent_create(small_explo_bmp,temp,small_explo);
		sleep(.1);
	}
	ent_remove(my);
}

function target_event {
	my.skill30 -= 5;
}

action target_fish {
	My.skill30 = 1;	
	my.enable_click = on;
	my.event = target_event;
	While(my != null) {
		My.pan += 5 * time;
		If(my.skill30 <= 0) {
			my.invisible = on;
			ent_create(gibbit_mdl,my.pos,explosion_maker);
			//ent_create(small_explo_bmp,my.pos,small_explo);
			ent_playsound(my,explosion_snd,1000);
			effect(explo_particle,200,my.pos,nullvector);
			sleep(.4);
			ent_playsound(my,explosion_snd,1000);
			effect(explo_particle,200,my.pos,nullvector);
			sleep(5);
			my.invisible = off;
			my.skill30 = 1;
		}
		wait(1);
	}
}

